diff --git a/hubs/tests/test_widgets/test_halp.py b/hubs/tests/test_widgets/test_halp.py
index 81c1831..ed60356 100644
--- a/hubs/tests/test_widgets/test_halp.py
+++ b/hubs/tests/test_widgets/test_halp.py
@@ -2,10 +2,10 @@ from __future__ import unicode_literals, absolute_import
 
 import json
 
-from hubs.models import Hub
-from hubs.tests import captured_templates
-from hubs.tests.test_widgets import WidgetTest
+from hubs.models import Hub, User
+from hubs.tests import FakeAuthorization
 from hubs.widgets import registry
+from . import WidgetTest
 
 
 SAMPLE_DATA = [
@@ -97,6 +97,7 @@ class HalpViewsTestCase(WidgetTest):
         dhrish = Hub.query.get("dhrish")
         dhrish.config.chat_channel = "#foss2serve"
         self.session.commit()
+        self.session.refresh(self.widget)
 
     def _get_sample_data_with_hub_keys(self):
         hub_names = ["infra", "devyani7", "dhrish", "decause", "decause"]
@@ -109,12 +110,11 @@ class HalpViewsTestCase(WidgetTest):
         return data
 
     def test_root(self):
-        with captured_templates(self.widget.module) as templates:
-            response = self.app.get('/ralph/w/halp/%i/' % self.widget.idx)
-        self.assertEqual(response.status_code, 200)
-        self.assertEqual(len(templates), 1)
-        _template, context = templates[0]
-        self.assertEqual(context["hubs"], ['fedora-devel'])
+        response = self.check_url('/ralph/w/halp/%i/' % self.widget.idx)
+        self.assertEqual(response.context["hubs"], ['fedora-devel'])
+
+    def test_view_authz(self):
+        self._test_view_authz()
 
     def test_json(self):
         response = self.app.get('/ralph/%i/json' % self.widget.idx)
@@ -124,30 +124,48 @@ class HalpViewsTestCase(WidgetTest):
         self.assertIn('hubs', data['data'].keys())
 
     def test_config_add(self):
-        with captured_templates(self.widget.module) as templates:
-            response = self.app.get('/ralph/w/halp/add?position=right')
-        self.assertEqual(response.status_code, 200)
-        self.assertEqual(len(templates), 1)
-        _template, context = templates[0]
-        self.assertEqual(context["mode"], "add")
-        self.assertEqual(context["initial"], {
+        user = FakeAuthorization('ralph')
+        response = self.check_url('/ralph/w/halp/add?position=right', user)
+        self.assertEqual(response.context["mode"], "add")
+        self.assertEqual(response.context["initial"], {
             "hubs": ["ralph"], "per_page": 4,
             })
-        self.assertEqual(context["url"], "/ralph/add/halp?position=right")
+        self.assertEqual(
+            response.context["url"], "/ralph/add/halp?position=right")
 
     def test_config_edit(self):
-        with captured_templates(self.widget.module) as templates:
-            response = self.app.get('/ralph/w/halp/%i/config'
-                                    % self.widget.idx)
-        self.assertEqual(response.status_code, 200)
-        self.assertEqual(len(templates), 1)
-        _template, context = templates[0]
-        self.assertEqual(context["mode"], "edit")
-        self.assertEqual(context["initial"], {
+        user = FakeAuthorization('ralph')
+        url = '/ralph/w/halp/%i/config' % self.widget.idx
+        response = self.check_url(url, user)
+        self.assertEqual(response.context["mode"], "edit")
+        self.assertEqual(response.context["initial"], {
             'hubs': ['fedora-devel'],
             'per_page': 3,
             })
-        self.assertEqual(context["url"], "/ralph/%i/edit" % self.widget.idx)
+        self.assertEqual(
+            response.context["url"], "/ralph/%i/edit" % self.widget.idx)
+
+    def test_config_authz(self):
+        urls = [
+            '/ralph/w/halp/add',
+            '/ralph/w/halp/%i/config' % self.widget.idx,
+            ]
+        # Anonymous
+        for url in urls:
+            self.check_url(url, None, 403)
+        # Logged-in
+        user = FakeAuthorization('decause')
+        for url in urls:
+            self.check_url(url, user, 403)
+        # Member
+        hub = Hub.query.get("ralph")
+        hub.subscribe(User.query.get("decause"), "member")
+        for url in urls:
+            self.check_url(url, user, 403)
+        # Owner
+        user = FakeAuthorization('ralph')
+        for url in urls:
+            self.check_url(url, user, 200)
 
     def test_config_hubs_suggest(self):
         response = self.app.get('/w/halp/hubs')
diff --git a/hubs/tests/test_widgets/test_library.py b/hubs/tests/test_widgets/test_library.py
index eaac331..6d85ad2 100644
--- a/hubs/tests/test_widgets/test_library.py
+++ b/hubs/tests/test_widgets/test_library.py
@@ -2,8 +2,8 @@ from __future__ import unicode_literals
 
 import json
 
-from hubs.tests import FakeAuthorization, auth_set
-from hubs.tests.test_widgets import WidgetTest
+from hubs.tests import FakeAuthorization
+from . import WidgetTest
 
 
 class TestLibrary(WidgetTest):
@@ -12,9 +12,7 @@ class TestLibrary(WidgetTest):
     def test_data_simple(self):
         widget = self.widget_instance('ralph', self.plugin)
         user = FakeAuthorization('ralph')
-        with auth_set(self.app.application, user):
-            response = self.app.get('/ralph/%i/json' % widget.idx)
-        self.assertEqual(response.status_code, 200)
+        response = self.check_url('/ralph/%i/json' % widget.idx, user)
         data = json.loads(response.get_data(as_text=True))
         expected_dict = {
             "config": {
@@ -34,3 +32,6 @@ class TestLibrary(WidgetTest):
             "plugin": "library"
         }
         self.assertDictEqual(data['data'], expected_dict['data'])
+
+    def test_view_authz(self):
+        self._test_view_authz()
diff --git a/hubs/tests/test_widgets/test_meetings.py b/hubs/tests/test_widgets/test_meetings.py
index 8c2784b..49f088b 100644
--- a/hubs/tests/test_widgets/test_meetings.py
+++ b/hubs/tests/test_widgets/test_meetings.py
@@ -2,8 +2,8 @@ from __future__ import unicode_literals
 
 import json
 
-from hubs.tests import FakeAuthorization, auth_set
-from hubs.tests.test_widgets import WidgetTest
+from hubs.tests import FakeAuthorization
+from . import WidgetTest
 
 
 class TestMeetings(WidgetTest):
@@ -13,9 +13,7 @@ class TestMeetings(WidgetTest):
         team = 'i18n'
         widget = self.widget_instance(team, self.plugin)
         user = FakeAuthorization('ralph')
-        with auth_set(self.app.application, user):
-            response = self.app.get('/%s/%i/json' % (team, widget.idx))
-        self.assertEqual(200, response.status_code)
+        response = self.check_url('/%s/%i/json' % (team, widget.idx), user)
         data = json.loads(response.get_data(as_text=True))
         calendar_name = data['data']['calendar']
         self.assertIn(team, calendar_name)
@@ -24,10 +22,11 @@ class TestMeetings(WidgetTest):
         team = 'i18n'
         widget = self.widget_instance(team, self.plugin)
         user = FakeAuthorization('ralph')
-        with auth_set(self.app.application, user):
-            response = self.app.get('/%s/w/%s/%i/'
-                                    % (team, self.plugin, widget.idx))
-        self.assertEqual(200, response.status_code)
+        url = '/%s/w/%s/%i/' % (team, self.plugin, widget.idx)
+        response = self.check_url(url, user)
         self.assertIn('i18n', response.get_data(as_text=True))
         self.assertIn('<strong>Request A New Meeting</strong>',
                       response.get_data(as_text=True))
+
+    def test_view_authz(self):
+        self._test_view_authz()
